Subject: Recursive diff noise for broken symlinks, fifos and sockets

From: Marcel Partap <[email-masked]>
Date: Mon, 15 Aug 2016 16:20:26 +0200

Dear diffutil devs,
when I copy large folder structures between harddisks, I like to check binary equality by running `diff -qr`. However, frequently the output is littered with powerful insights such as:
# File /mnt/source-xfs/repositories/kindlepdfviewer/emu_event is a fifo while file /usr/src/repositories/kindlepdfviewer/emu_event is a fifo
# File /mnt/source-xfs/repositories/android/i927-downloads/lost+found/#16412 is a socket while file /usr/src/repositories/android/i927-downloads/lost+found/#16412 is a socket
This does sound somewhat delusional.
Also, matching failures for broken symlinks:
# diff: /mnt/source-xfs/repositories/par2cmdline/test-driver: No such file or directory
# diff: /usr/src/repositories/par2cmdline/test-driver: No such file or directory
Additionally, recursive directory loops are being pointed out, but only on one side.

What I actually care for is missing and different files, not if there are broken symlinks, dir loops or fifos in the cloned directory hierarchy.
The documentation reads
>         -q, --brief
>                report only when files differ
so I think, it actually should do that. Is there any way at all fifos or sockets can actually differ?
I have no idea how to fix this, but hopefully someone else has : )

#Best Regards/Marcel Partap